<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
      <el-form-item label="名称" prop="name">
        <el-input v-model="formData.name" placeholder="请输入名称" />
      </el-form-item>
      <el-form-item label="视频编号" prop="code">
        <el-input v-model="formData.code" placeholder="请输入视频编号" />
      </el-form-item>
      <el-form-item label="排序" prop="sort">
        <el-input-number v-model="formData.sort" :min="1" :max="1000" controls-position="right" />
      </el-form-item>
      <el-form-item label="类型" prop="type">
        <el-select v-model="formData.type" placeholder="请选择类型">
          <el-option
            v-for="dict in getStrDictOptions(DICT_TYPE.SAFE_CAMERA_TYPE)"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="后端设备" prop="serverId">
        <el-select v-model="formData.serverId" placeholder="请选择后端设备">
          <el-option
            v-for="server in serverList"
            :key="server.id"
            :label="server.name"
            :value="server.id"
        >
            <span style="float: left">{{ server.name }}</span>
            <span
              style="
                float: right;
                color: var(--el-text-color-secondary);
                font-size: 10px;
              "
            >
              {{ server.protocol +'://'+server.ip+':'+server.port+'/'+server.domain }}
            </span>
          </el-option>
        </el-select>
      </el-form-item>
      <el-form-item label="AI模型" prop="aiMode">
        <el-select v-model="formData.aiMode" placeholder="请选择AI模型">
          <el-option
            v-for="dict in getStrDictOptions(DICT_TYPE.SAFE_AI_MODE)"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="报警状态" prop="warn">
        <el-select v-model="formData.warn" placeholder="请选择报警状态">
          <el-option
            v-for="dict in getStrDictOptions(DICT_TYPE.COMMON_STATUS)"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="报警接口" prop="warnApi">
        <el-input v-model="formData.warnApi" placeholder="请输入报警接口" />
      </el-form-item>
      <el-form-item label="描述" prop="des">
        <el-input v-model="formData.des" type="textarea" placeholder="请输入描述" />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { getStrDictOptions, DICT_TYPE } from '@/utils/dict'
import { CameraApi, CameraVO } from '@/api/safe/camera'
import { ServerApi } from '@/api/safe/server'

/** 安防前端设备 表单 */
defineOptions({ name: 'CameraForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

let serverList = ref([])//后端设备列表
const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  name: undefined,
  code: undefined,
  sort: undefined,
  type: undefined,
  serverId: undefined,
  aiMode: undefined,
  warn: undefined,
  warnApi: undefined,
  des: undefined,
})
const formRules = reactive({
  name: [{ required: true, message: '名称不能为空', trigger: 'blur' }],
  code: [{ required: true, message: '视频编号不能为空', trigger: 'blur' }],
  serverId: [{ required: true, message: '后端设备不能为空', trigger: 'change' }],
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  serverList.value = await ServerApi.getAllServer()
  if (id) {
    formLoading.value = true
    try {
      formData.value = await CameraApi.getCamera(id)
    } finally {
      formLoading.value = false
    }
  }
}

defineExpose({ open}) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as CameraVO
    if (formType.value === 'create') {
      await CameraApi.createCamera(data)
      message.success(t('common.createSuccess'))
    } else {
      await CameraApi.updateCamera(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    name: undefined,
    code: undefined,
    sort: undefined,
    type: undefined,
    serverId: undefined,
    aiMode: undefined,
    warn: undefined,
    warnApi: undefined,
    des: undefined,
  }
  formRef.value?.resetFields()
}
</script>